
N = c(10,20,50,100,500,1000) 
P = c(0.05,0.1,0.25,0.5)

library(boot)
# Normal Approximation to Binomial
Binom_Normal_Conf <- function(n,p){
estimate_p <-mean(rbinom(n,1,p))
SE=estimate_p * (1-estimate_p) / n
return(norm.ci(t0=estimate_p,var.t0=SE)[2:3])
}

#Bootstrap -t and Boostrap percentile Confidence interval 
#for Bootsrtap-percentile p=TRUE

bs.t.p.conf <- function(n,p,statistic, alpha=0.95,B=100,B1=50,bs.p=FALSE)
{
		
	data=rbinom(n,1,p)	
	T <-mean(data)
	Boot_B<-as.table(replicate(B,sample(data,replace=TRUE)))
	se=seq(B)
	Boot_estimate<-sapply(se, function(m){
		mean(Boot_B[,m]) })
        
	z=sapply(se , function(m){
	(Boot_estimate[m] - T) / sqrt(var(Boot_B[,m]) / n ) })
	if(var(data))	
	  conf.t<-T-quantile(z,  probs = c(0.975,0.025),na.rm=TRUE)*sqrt(var(data)/n)
	else 
	  conf.t=c(T,T)
	conf.p<-  quantile(Boot_estimate,  probs = c(0.025,0.975),na.rm=TRUE)
	if(bs.p)
		return(conf.p)
	else
		return( conf.t)  
			
				
}

for( m in 1:length(N))
for( p in 1:length(P))
bs.t.p.conf(N[m],P[p]))


# coverage Probability  

Covg_Prob<-function(x,B=50,n,p,l=FALSE){  # x: confidence intervals i.e. 							Lower and Upper bounds 
	nrep=length(x)/2	# no of confidence intervals 
	count=0			#count-no of times CIs include the 							true value of the paraeter 
	for(i in 1:nrep)
		if((p<=x[2,i])&& (p>=x[1,i]))
		count= count+1
	if(l)				# if true then return average lenth 							of the CI
		return( list(mean(x[2,]-x[1,]) , count/nrep))
	else				
		return(count/nrep)

}

# function to get Coveage probabilty for 3 type of CIs (Normal,boot-t,Boot-p)

Compare_Covg_Prob<-function(nrep,n,p,B=50){
x=replicate(nrep,Binom_Normal_Conf(n,p))
y=replicate(nrep,bs.t.p.conf(n,p))
z=replicate(nrep,bs.t.p.conf(n,p,bs.p=TRUE))
cx=Covg_Prob(x,B,n,p)
cy=Covg_Prob(y,B,n,p)
cz=Covg_Prob(z,B,n,p)
return(c(cx,cy,cz))
}

nrep=5000
covg.tab=matrix(0,3,6)   #matrix of covg prob for 6 different values of n


for(i in 1:6)
covg.tab[,i]<-t(Compare_Covg_Prob(nrep,n=N[i],p=P[1]))

# funcion for plot of confidence intervals found using Normal approximation 

plot_C(B=50,n=100,p=0.5){
x=replicate(B,Binom_Normal_Conf(n,p))
contain<-(x[2,]>=p)&(p>=x[1,])
plot(0,0,type="n",xlim=c(0,1),ylim=c(0,B))
c=ifelse(contain,"black","red")
segments(t(x)[,1],1:B ,t(x)[,2],1:B,col=c)
abline(v=p,col="blue")
}

